; GIMP - The GNU Image Manipulation Program
; Copyright (C) 1995 Spencer Kimball and Peter Mattis
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
;
; 
; The script can be found on an open image in GIMP 2.6 under: Filters > Light and Shadow > Plastic Wrap All Layers...

; 



; Define the Function

(define (script-fu-plasti-wrap-all-layers 	image		 
				drawable
				radius
				)

; Declare the Variables

	(let* (
		    	(activeLayer nil)
			(counter nil)
			(numLayers nil)
			(allLayersRef nil)
			(baseType nil)
			(origSelect nil)
			(waxLayer1 nil)
			(waxLayer2 nil)
			(copyLayer nil)		
)

(gimp-context-push)
(gimp-image-undo-group-start image)


(set! origSelect (car (gimp-selection-save image)))
(gimp-selection-none image) 


(set! counter (car (gimp-image-get-layers image)))
(set! numLayers (car (gimp-image-get-layers image)))
(set! allLayersRef (cadr (gimp-image-get-layers image)))

	(while (> numLayers 0)
	(set! activeLayer (car (gimp-image-set-active-layer image (aref allLayersRef (- numLayers 1)))))
	(set! activeLayer (car (gimp-image-get-active-layer image))) 
	(gimp-drawable-set-visible activeLayer TRUE)
	(set! waxLayer1 (car (gimp-layer-copy activeLayer TRUE)))
	(set! waxLayer2 (car (gimp-layer-copy activeLayer TRUE)))
	(gimp-image-add-layer image waxLayer1 -1)	
	(gimp-image-add-layer image waxLayer2 -1)
	(gimp-desaturate waxLayer1)
	(gimp-desaturate waxLayer2)
	(gimp-invert waxLayer2)
	(plug-in-neon RUN-NONINTERACTIVE image waxLayer1 radius 0)
	(plug-in-neon RUN-NONINTERACTIVE image waxLayer2 radius 0)
	(gimp-layer-set-mode waxLayer2 SCREEN-MODE)
	(gimp-image-merge-down image waxLayer2 CLIP-TO-BOTTOM-LAYER)
	(set! activeLayer (car (gimp-image-get-active-layer image)))
	(set! copyLayer (car (gimp-layer-copy activeLayer TRUE)))
	(gimp-image-add-layer image copyLayer -1)
	(gimp-layer-set-mode copyLayer DIVIDE-MODE)
	(gimp-image-merge-down image copyLayer CLIP-TO-BOTTOM-LAYER)
	(set! activeLayer (car (gimp-image-get-active-layer image)))
	(gimp-invert activeLayer)
	(gimp-layer-set-mode activeLayer SCREEN-MODE)
	(gimp-image-merge-down image activeLayer CLIP-TO-BOTTOM-LAYER)
	(set! activeLayer (car (gimp-image-get-active-layer image)))	
	(set! numLayers (- numLayers 1))
	)










(gimp-selection-load origSelect)
(gimp-image-remove-channel image origSelect) 	

(gimp-image-undo-group-end image)
(gimp-context-pop)
(gimp-displays-flush)


  )
)

(script-fu-register "script-fu-plasti-wrap-all-layers"
  "<Image>/Filters/Light and Shadow/Plastic Wrap All Layers..."
  "Apply a Plastic Wrap effect to all layers of an image."
  "Art Wade"
  "Art Wade"
  "February 12, 2010"
  "RGB*"
SF-IMAGE       	"Image" 0
SF-DRAWABLE    	"Drawable" 0
SF-ADJUSTMENT "Plastic Amount (Lower values means more plastic)" '(5 1 100 1 2 0 1)
)


                         

