; GIMP - The GNU Image Manipulation Program
; Copyright (C) 1995 Spencer Kimball and Peter Mattis
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
;
;
;
; Script can be found under Filters > Animation > Animated Polar Coordinates...



; Define the Function

(define (fp-script-fu-anim-polar-coords
	img		 
				drawable
				pingPong
				depth
				depthFinish
				angle
				angleFinish
				backwards 
				fromTop 
				toPolar
				)

; Declare the Variables

	(let* (
		    	(theSelection 0)
			(counter 0)
			(counter2 0)
			(allLayersRef 0)
			(activeLayer 0)	
			(depthInc 0)
			(angleInc 0)

		)	




(gimp-context-push)
(gimp-image-undo-group-start img)
(set! theSelection (car (gimp-selection-save img)))
(gimp-selection-none img)
(set! counter (car (gimp-image-get-layers img)))
(set! counter2 counter)
(set! allLayersRef (cadr (gimp-image-get-layers img)))
(if (= pingPong TRUE)
	(begin
		(set! depthInc (/ (- depthFinish depth) (ceiling (/ counter 2)))) 
		(set! angleInc (/ (- angleFinish angle) (ceiling (/ counter 2))))
	)
	
	(begin
		(set! depthInc (/ (- depthFinish depth) counter))
		(set! angleInc (/ (- angleFinish angle) counter))
	)
)



(while (> counter 0)

(set! activeLayer (car (gimp-image-set-active-layer img (aref allLayersRef (- counter 1)))))
(set! activeLayer (car (gimp-image-get-active-layer img)))
(gimp-layer-add-alpha activeLayer)

(plug-in-polar-coords RUN-NONINTERACTIVE img activeLayer depth angle backwards fromTop toPolar)

(if (and (= pingPong TRUE) (<= counter (ceiling (/ counter2 2))))
	(begin
		(set! depth (- depth depthInc))
		(set! angle (- angle angleInc))
	)

	(begin
		(set! depth (+ depth depthInc))
		(set! angle (+ angle angleInc))
	)
)

(set! counter (- counter 1))
)


		

(gimp-image-set-active-layer img drawable)
(gimp-selection-load theSelection)
(gimp-image-remove-channel img theSelection)

(gimp-image-undo-group-end img)

(gimp-context-pop)

(gimp-displays-flush)


  )
)

(script-fu-register "fp-script-fu-anim-polar-coords"
  "<Image>/Filters/Animation/Animators/Animated Polar Coordinates..."
  "Run Polar Coordinates filter on all layers in an image. Defaults create a square mapping."
  "Art Wade"
  "Art Wade"
  "February 5, 2010"
  "RGB*"
  SF-IMAGE       	"Image" 0
  SF-DRAWABLE    	"Drawable" 0
  SF-TOGGLE		"Ping-Pong Mode"	FALSE
  SF-ADJUSTMENT	"Circle Depth Start" '(0.0 -720.0 720.0 1 1 1)  
  SF-ADJUSTMENT	"Circle Depth Finish" '(0.0 -720.0 720.0 1 1 1)  
  SF-ADJUSTMENT	"Offset Angle Start" '(0.0 -359.0 359.0 1 1 1)   
  SF-ADJUSTMENT	"Offset Angle Finish" '(0.0 -359.0 359.0 1 1 1)   
  SF-TOGGLE		"Map Backwards" FALSE
  SF-TOGGLE		"Map From Top" TRUE
  SF-TOGGLE		"To Polar" TRUE
)


                         
