; GIMP - The GNU Image Manipulation Program
; Copyright (C) 1995 Spencer Kimball and Peter Mattis
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
;
;
;
; Script can be found under Colors > Modify > Color to Alpha All Layers...


; Define the Function

(define (fp-script-fu-color-alpha-all-layers
	img		 
				drawable
				color
				)


(gimp-context-push)
(gimp-image-undo-group-start img)


(map (lambda (x) (plug-in-colortoalpha RUN-NONINTERACTIVE img x color)) (vector->list (cadr (gimp-image-get-layers img))))

(gimp-image-set-active-layer img drawable)

(gimp-image-undo-group-end img)

(gimp-context-pop)

(gimp-displays-flush)

)

(script-fu-register "fp-script-fu-color-alpha-all-layers"
  "<Image>/Colors/Modify/Color to Alpha All Layers..."
  "Convert a specified color to transparent on all layers in an image."
  "Art Wade"
  "Art Wade"
  "February 10, 2010"
  "RGB*"
  SF-IMAGE       	"Image" 0
  SF-DRAWABLE    	"Drawable" 0
  SF-COLOR		"Color to make transparent" '(255 255 255) 

)


                         
