; GIMP - The GNU Image Manipulation Program
; Copyright (C) 1995 Spencer Kimball and Peter Mattis
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
;
;
;
; Script can be found under Filters/Edge-Detect/Edge Detect All Layers...



; Define the Function

(define (fp-script-fu-multi-edge-detect
	img		 
				drawable
				algorithm
				amount
				wrap
				)

; Declare the Variables

	(let* (
		    	(theSelection 0)
	
		)	




(gimp-context-push)
(gimp-image-undo-group-start img)
(set! theSelection (car (gimp-selection-save img)))
(gimp-selection-none img)


(map (lambda (x) (plug-in-edge RUN-NONINTERACTIVE img x amount wrap algorithm)) (vector->list (cadr (gimp-image-get-layers img))))

(gimp-image-set-active-layer img drawable)
(gimp-selection-load theSelection)
(gimp-image-remove-channel img theSelection)

(gimp-image-undo-group-end img)

(gimp-context-pop)

(gimp-displays-flush)


  )
)

(script-fu-register "fp-script-fu-multi-edge-detect"
  "<Image>/Filters/Edge-Detect/Edge Detect All Layers..."
  "Run Edge Detect filter on all layers in an image."
  "Art Wade"
  "Art Wade"
  "February 10, 2010"
  "RGB* GRAY*"
  SF-IMAGE       	"Image" 0
  SF-DRAWABLE    	"Drawable" 0
  SF-OPTION		"Algorithm" '("Sobel" "Prewitt Compass" "Gradient" "Roberts" "Differential" "Laplace")  
  SF-ADJUSTMENT	"Amount" '(2.0 1.0 10.0 1 1 1)  
  SF-OPTION		"Wrap Mode" '("Wrap" "Smear" "Black")  

  

)


                         
