; GIMP - The GNU Image Manipulation Program
; Copyright (C) 1995 Spencer Kimball and Peter Mattis
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
;
;
;
; Script can be found under Colors > Map > Gradient Map All Layers...


; Define the Function

(define (fp-script-fu-gradient-map-all
	img		 
				drawable
				gradient
				gradInvert
				foreground
				background
				)


(gimp-context-push)
(gimp-image-undo-group-start img)

(gimp-context-set-foreground foreground)
(gimp-context-set-background background)
(gimp-context-set-gradient gradient)

(if (= gradInvert TRUE)
(map (lambda (x) (gimp-invert x)) (vector->list (cadr (gimp-image-get-layers img))))
)


(map (lambda (x) (plug-in-gradmap RUN-NONINTERACTIVE img x)) (vector->list (cadr (gimp-image-get-layers img))))

(gimp-image-undo-group-end img)

(gimp-context-pop)

(gimp-displays-flush)


)

(script-fu-register "fp-script-fu-gradient-map-all"
  "<Image>/Colors/Map/Gradient Map All Layers..."
  "Recolor all the layers in an image using the chosen gradient."
  "Art Wade"
  "Art Wade"
  "February 16, 2010"
  "RGB* GRAY*"
  SF-IMAGE       	"Image" 0
  SF-DRAWABLE    	"Drawable" 0
  SF-GRADIENT	"Gradient" "Incandescent"
  SF-TOGGLE       "Invert Gradient?" FALSE
  SF-COLOR		"Foreground Color (Only used if one of the gradient choices uses FG-BG method)" '(0 0 0)
  SF-COLOR		"Background Color (Only used if one of the gradient choices uses FG-BG method)" '(255 255 255)

)


                         
