; GIMP - The GNU Image Manipulation Program
; Copyright (C) 1995 Spencer Kimball and Peter Mattis
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
;
;
;
; Script can be found under Layer > Transparency > Semi-Flatten All Layers...


; Define the Function

(define (fp-script-fu-semi-flatten-all-layers
	img		 
				drawable
				color
				)


(gimp-context-push)
(gimp-image-undo-group-start img)

(gimp-context-set-background color)
(map (lambda (x) (plug-in-semiflatten RUN-NONINTERACTIVE img x)) (vector->list (cadr (gimp-image-get-layers img))))

(gimp-image-set-active-layer img drawable)

(gimp-image-undo-group-end img)

(gimp-context-pop)

(gimp-displays-flush)

)

(script-fu-register "fp-script-fu-semi-flatten-all-layers"
  "<Image>/Layer/Transparency/Semi-Flatten All Layers..."
  "Replace partial transparency in all layers with the chosen background color."
  "Art Wade"
  "Art Wade"
  "February 11, 2010"
  "RGBA"
  SF-IMAGE       	"Image" 0
  SF-DRAWABLE    	"Drawable" 0
  SF-COLOR		"Color to replace partial transparency with" '(255 255 255) 

)


                         
