; GIMP - The GNU Image Manipulation Program
; Copyright (C) 1995 Spencer Kimball and Peter Mattis
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
;
;
;
; Script can be found under Filters > Animation > Space Tunnel...



; Define the Function

(define (fp-space-tunnel 	img		 
				drawable
				)

; Declare the Variables

	(let* (
		    	(theSelection 0)
		)	




(gimp-context-push)
(gimp-image-undo-group-start img)
(set! theSelection (car (gimp-selection-save img)))
(gimp-selection-none img)

(map (lambda (x) (plug-in-map-object RUN-NONINTERACTIVE  img x 
			3				; mapping
			0.5 0.5 2.0			; viewpoint
			0.5 0.5 2.0			; object pos
			1.0 1.0 0.0			; first axis
			1.0 1.0 0.0			; 2nd axis
		      90.0 0.0 0.0		; axis rotation
		      2 '(255 255 255)		; light (type, color)
			-0.5 -0.5 2.0		; light position
		      -1.0 -1.0 1.0		; light direction
			0.3 1.0 0.5 0.0 27.0	; material (amb, diff, refl, spec, high)
			TRUE				; antialias
			FALSE				; tile
			FALSE				; new image
			1				; transparency
			0.009				; radius
			-1 -1 -1			; box size (x,y,z)
			2.0				; cylinder length
			-1 -1 -1 -1 -1 -1 	; box faces 1-6
			x x)) 			; cylinder top/bottom faces	
			(vector->list (cadr (gimp-image-get-layers img)))
)

(map (lambda (x) (plug-in-whirl-pinch RUN-NONINTERACTIVE img x 0.0 1.0 0.005))(vector->list (cadr (gimp-image-get-layers img))))


(gimp-image-set-active-layer img drawable)

(gimp-selection-load theSelection)
(gimp-image-remove-channel img theSelection)

(gimp-image-undo-group-end img)

(gimp-context-pop)

(gimp-displays-flush)


  )
)

(script-fu-register "fp-space-tunnel"
  "<Image>/Filters/Animation/Animators/Space Tunnel..."
  "Create an animated space tunnel effect on an existing animation"
  "Art Wade"
  "Art Wade"
  "February 6, 2010"
  "RGB*"
  SF-IMAGE       	"Image" 0
  SF-DRAWABLE    	"Drawable" 0
   
)


                         
